"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Basic_1 = require("../templates/Basic");
var NavView = /** @class */ (function (_super) {
    __extends(NavView, _super);
    function NavView(props) {
        var _this = _super.call(this, props) || this;
        _this.createPath = function () {
            return _this.props.parentId ? _this.props.parentId + "|" + _this.props.id : _this.props.id;
        };
        _this.dispatchOnClick = function () {
            var arg = {
                id: _this.props.id,
                path: _this.createPath(),
                payload: _this.props.payload
            };
            if (_this.props.onClick) {
                try {
                    _this.props.onClick(__assign({}, arg));
                }
                catch (e) {
                    // ignored
                }
            }
            if (_this.props.context.onItemSelection) {
                _this.props.context.onItemSelection(arg);
            }
        };
        return _this;
    }
    NavView.prototype.render = function () {
        var _a = this.props, children = _a.children, context = _a.context, id = _a.id;
        var template = this.props.context.template;
        var isChild = this.props.parentId !== undefined;
        var Template = isChild ? template.navChild || Basic_1.NavChildTemplate : (template.nav || Basic_1.NavTemplate);
        var path = this.createPath();
        var navStateProp = {
            theme: context.theme || {},
            selected: id !== undefined && context.selectedPath === path,
            expanded: undefined,
            navProp: this.props,
            level: this.props.parentId ? 1 : 0,
            template: this.props.context.template
        };
        return (React.createElement("div", { onClick: this.dispatchOnClick },
            React.createElement(Template, __assign({}, navStateProp), children || null)));
    };
    return NavView;
}(React.PureComponent));
exports.NavView = NavView;
//# sourceMappingURL=NavView.js.map